local f = CreateFrame("Frame");

local debug = false

local addonChatFrame = CreateFrame("Frame")
local dingColor = "|cFFFFCC00"
local statColor = "|cFF00FF00"
local defaultColor = "|cFF00FFFF"
local baseColor = "|cFFFFFF00"
local soundPath = "Interface\\AddOns\\PokemonLvl\\sounds\\"

local ADDON_PREFIX = "pkmnlvl"

local addonChannelSuccess = RegisterAddonMessagePrefix(ADDON_PREFIX)

print(baseColor .. "Addon Channel Success: " .. statColor .. tostring(addonChannelSuccess))

f:RegisterEvent("PLAYER_LEVEL_UP")
--f:RegisterEvent("UNIT_")

f:SetScript("OnEvent", function(self, event, newLvl, hpGain, manaGain, talentPoints, strg, agil, stam, inte, spir)

	displayChanges(newLvl, hpGain, manaGain, talentPoints, strg, agil, stam, inte, spir)	
		
end);





addonChatFrame:RegisterEvent("CHAT_MSG_ADDON")
addonChatFrame:SetScript("OnEvent", function(self, event, prefix, message, distroType, sender)

	if debug == true then
		print(prefix)
		print(message)
		print(distroType)
		print(sender)
	end

	if (prefix == ADDON_PREFIX) then
		
		--start, sEnd = split(message, ",")
		start = string.sub(message, 0, string.find(message, ":")-1)
		sEnd = string.sub(message, string.find(message, ":")+1, message:len())

		if debug == true then
			print(start)
			print(sEnd)
		end

		if (message == "ding") then
			PlaySound("LEVELUPSOUND", "master")

		end

		if (start == "SOUND") then
			PlaySound(sEnd, "master")

		end

		if (start == "SOUNDFILE") then
			PlaySoundFile(soundPath .. sEnd, "master")
		end
	end	
end)

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end





SLASH_DING1 = '/dinging'; -- 3.
function SlashCmdList.DING(msg, editbox) -- 4.
	PlaySound("LEVELUPSOUND", "master")
	displayChanges(UnitLevel("player")+1, 12, 3, 1, 3, 2, 9, 12, 5)	
end




SLASH_TROLLS1 = '/pkmn'; -- 3.
function SlashCmdList.TROLLS(msg, editbox) -- 4.
	--print("DONE!")
	--SendAddonMessage(ADDON_PREFIX, "ding", "PARTY")

	--local command, var, target = msg:match("^(%S*)%s*(.-)$");
	local command, varUSELESS = msg:match("^(%S*)%s*(.-)$");
	local var, target = varUSELESS:match("^(%S*)%s*(.-)$");
 -- Any leading non-whitespace is captured into command;
 -- the rest (minus leading whitespace) is captured into rest.

	
 	if debug == true then
		print(command)
		print(var)
		print(target)
	end

	local channel = "PARTY"
	local requireTarget = false;

 	if (target ~= nil and target ~= "") then
 		channel = "WHISPER"
 		requireTarget = true

 		if target == "GUILD" then
 			channel = "GUILD"
 			requireTarget = false
 		end	

 		print(tostring(requireTarget) .. " - " .. channel)
 	end	

 	
 	local groupSize = GetNumGroupMembers()
 	if requireTarget == false then 
	 	if groupSize == 0 then
	 		channel = "GUILD"
	 	else 
	 		channel = "PARTY"
	 	end	
 	end
 	print(dingColor .. "Addon Messages going through " .. statColor .. channel)

 	if command == "dingsound" then
  -- Handle adding of the contents of rest... to something.
  	 	if requireTarget == true then 
  			SendAddonMessage(ADDON_PREFIX, "ding", channel, target)
  		else 
			SendAddonMessage(ADDON_PREFIX, "ding", channel)
  		end 	
  		print("|cffff00ffDING!")
 	elseif command == "sound" then
  -- Handle removing of the contents of rest... to something.   
  	
		if requireTarget == true then 
  			SendAddonMessage(ADDON_PREFIX, "SOUND:" .. var, channel, target)
  		else 
			SendAddonMessage(ADDON_PREFIX, "SOUND:" .. var, channel)
  		end 

  		print("|cffff00ffSound |cff0000ff"..var.."!")
	 end

	 if command == "wipe" then
  -- Handle removing of the contents of rest... to something.   
  	
		if requireTarget == true then 
  			SendAddonMessage(ADDON_PREFIX, "SOUNDFILE:" .. "fail.mp3", channel, target)
  		else 
			SendAddonMessage(ADDON_PREFIX, "SOUNDFILE:" .. "fail.mp3", channel)
  		end 

  		print("|cffff00ffSound |cff0000ffWIPE!")
	 end

	 if command == "boss" then
  -- Handle removing of the contents of rest... to something.   
  	
		if requireTarget == true then 
  			SendAddonMessage(ADDON_PREFIX, "SOUNDFILE:" .. "boss.mp3", channel, target)
  		else 
			SendAddonMessage(ADDON_PREFIX, "SOUNDFILE:" .. "boss.mp3", channel)
  		end 

  		print("|cffff00ffSound |cff0000ffBOSS!")
	 end

	 if command == "battlecry" then
  -- Handle removing of the contents of rest... to something.   
  	
		if requireTarget == true then 
  			SendAddonMessage(ADDON_PREFIX, "SOUNDFILE:" .. "battlecry.mp3", channel, target)
  		else 
			SendAddonMessage(ADDON_PREFIX, "SOUNDFILE:" .. "battlecry.mp3", channel)
  		end 

  		print("|cffff00ffSound |cff0000ffBATTLECRY!")
	 end

end

SLASH_WIPE1 = '/wipe'; -- 3.
SlashCmdList["WIPE"] = function (msg, editbox) -- 4.
	--print("DONE!")
	--SendAddonMessage(ADDON_PREFIX, "ding", "PARTY")
	PlaySoundFile(soundPath .. "fail.mp3", "master")
	
end

SLASH_DEBUG1 = '/addondebug'; -- 3.
SlashCmdList["DEBUG"] = function (msg, editbox) -- 4.
	--print("DONE!")
	--SendAddonMessage(ADDON_PREFIX, "ding", "PARTY")
	if msg == "on" then 
		debug = true
	elseif msg == "off" then
		debug = false
	end	
end
--
-- LEVEL UP STUFF
--

function displayChanges(lvl, hpG, manaG, talentG, strG, agilG, stamG, inteG, spirG)
	print(defaultColor .. " ~~ " .. dingColor .. "--- DING! " .. statColor .. lvl .. dingColor .. " ---")


	--HP stat, change
	print( formatString("HP  ", UnitHealthMax("player"), hpG) )

	--Mana stat, change
	print( formatString("Mana", UnitHealthMax("player"), manaG) )

	-- talents stat, change
	print( formatString("TP  ", "?", talentG) )

	-- str stat, change
	print( formatString("Strg", statBase(1), strG) )

	--agil stat, change
	print( formatString("Agil", statBase(2), agilG) )

	--stam stat, change
	print( formatString("Stam", statBase(3), stamG) )

	--inte stat, change
	print( formatString("Intl", statBase(4), inteG) )

	--spir stat, change
	print( formatString("Spir", statBase(5), spirG) )

end 

function statBase(statID)
	local base, stat, posBuff, negBuff = UnitStat("player", statID);
	return base
end	

function formatString(sStat, curVal, changeVal)
	local newString = (defaultColor .. " ~~ " .. sStat .. " : " .. baseColor .. curVal .. defaultColor .. " (" .. statColor .. "+" .. changeVal .. defaultColor .. ")")
	return newString
end 


